/*******************************************************************************
 * FoxSquadInfo generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSquadInfo extends Actor
    transient
    native(AI)
    notplaceable
    hidecategories(Navigation);

enum ESquadBehaviorSetting
{
    SBS_Passive,
    SBS_Aggressive,
    SBS_MAX
};

enum ESquadCommandType
{
    SCT_GoToArea,
    SCT_Regroup,
    SCT_MAX
};

enum ESquadFormationMode
{
    SFM_Circle,
    SFM_MAX
};

struct native SquadMemberInfo
{
    var transient Controller SqCont;
    var int FormationIndex;

    structdefaultproperties
    {
        SqCont=none
        FormationIndex=0
    }
};

var FoxTeamInfo Team;
var name SquadName;
var int SquadIndex;
var Controller SquadLeader;
var array<SquadMemberInfo> SquadMembers;
var FoxSquadInfo.ESquadBehaviorSetting SquadBehavior;
var private bool bSquadGod;
var private bool bAnchored;
var private bool bSquadLocationChanged;
var private float SquadTightRadius;
var private float SquadRadiusBuffer;
var private float SquadRadius;
var private Vector PreviousSquadLocation;
var private Vector SquadLocation;
var private Vector SquadColor;
var float UpdateFollowDestInterval;
var private float LeadingDirectionDist;
var private float SquadUpdateFrequency;
var private float NextSquadUpdate;
var private Actor AnchorActor;
var private Vector AnchorLocation;
var private Rotator AnchorDirection;
var private Vector LastSquadLocation;
var Rotator SquadDirection;
var private FoxAISquadFormation CurrentFormation;
var private array<SquadFormationNode> CurrentSquadFormationLocations;
var private int DefaultFormationIndex;
var private array<FoxAISquadFormation> AvailableFormations;

// Export UFoxSquadInfo::execAddMemberToSquad(FFrame&, void* const)
native function AddMemberToSquad(Controller Other);

// Export UFoxSquadInfo::execRemoveMemberFromSquad(FFrame&, void* const)
native function RemoveMemberFromSquad(Controller Other);

// Export UFoxSquadInfo::execFindSquadMember(FFrame&, void* const)
native function int FindSquadMember(const optional Controller Other, const optional FoxPawn Pawn);

// Export UFoxSquadInfo::execSetSquadBehavior(FFrame&, void* const)
native function SetSquadBehavior(const FoxSquadInfo.ESquadBehaviorSetting NewSquadBehavior);

// Export UFoxSquadInfo::execSetAnchor(FFrame&, void* const)
native function SetAnchor(optional Actor InAnchorActor, optional Vector InAnchorLocation);

// Export UFoxSquadInfo::execClearAnchor(FFrame&, void* const)
native function ClearAnchor();

// Export UFoxSquadInfo::execToggleSquadGod(FFrame&, void* const)
native function ToggleSquadGod();

// Export UFoxSquadInfo::execUpdateFollowDestinations(FFrame&, void* const)
native function UpdateFollowDestinations();

// Export UFoxSquadInfo::execGetFollowLocation(FFrame&, void* const)
native function Vector GetFollowLocation(const Controller Other);

function OnFoxAISeqAct_MoveTo(FoxAISeqAct_MoveTo Action)
{
    local int I;
    local FoxAIControllerInterface Cont;

    I = 0;
    J0x0B:
    // End:0xE3 [Loop If]
    if(I < SquadMembers.Length)
    {
        Cont = FoxAIControllerInterface(SquadMembers[I].SqCont);
        // End:0xD5
        if(Cont != none)
        {
            Cont.ProcessBehaviorEvent("Command GoTo", none, Action.TargetDestination, Action.TargetLocation);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

// Export UFoxSquadInfo::execSquadBehaviorEvent(FFrame&, void* const)
native function SquadBehaviorEvent(string EventName, optional Actor EventInstigator, optional Actor EventRecipient, optional Vector EventLocation);

defaultproperties
{
    SquadBehavior=ESquadBehaviorSetting.SBS_Aggressive
    bSquadLocationChanged=true
    SquadRadiusBuffer=2048.0
    UpdateFollowDestInterval=1.0
    LeadingDirectionDist=-5.0
    SquadUpdateFrequency=0.20
    begin object name=Circle class=FoxAISquadFormation_Circle
        Radius=170.0
    object end
    // Reference: FoxAISquadFormation_Circle'Default__FoxSquadInfo.Circle'
    AvailableFormations(0)=Circle
    TickGroup=ETickingGroup.TG_DuringAsyncWork
}